/* sends a one character message through UNIX socket to tell sleepy daemon
 * to do something with the drive...
 *
 * This needs to run setuid root to access the socket...
 *
 *  chief value of ignore is for fsck, mkfs, scarface analysis, etc...
 *
 *  This software is provided with NO warranty regarding any application
 *  or purpose.
 *
 *  It may be stapled, folded, mutilated and otherwise used and abused
 *  in whatever fashion its user sees fit.
 *
 *  sgf@cfm.brown.edu
 */

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/fcntl.h>
#include <stdio.h>
#include <stdlib.h>
#include <getopt.h>
#include <mntent.h>
#include <string.h>
#include <malloc.h>
#include <dslib.h>
#include <sys/socket.h>
#include <sys/un.h>
#include <errno.h>

#define EJECT 'E'
#define IGNORE 'I'

#define SOCKETNAME "/tmp/.eyeear"

int main(argc, argv)
int argc;
char **argv;
{
	char   buf[BUFSIZ];
	
	int s, n, cmd;
	struct sockaddr_un earwhere;

	if (argc != 2) {
usage:
	    fprintf(stderr, "\nusage: %s [-e] [-i]\n", argv[0]);
	    fprintf(stderr, "\t'%s -e' unmounts and ejects\n", argv[0]);
	    fprintf(stderr, "\t'%s -i' unmounts and ignores for maintenance\n",
						 argv[0]);
	    fprintf(stderr, "\t'%s -w' wakes up after an ignore\n", argv[0]);
	    exit(1);
	}
	if ( argv[1][0] != '-' ) goto usage;
	switch (argv[1][1]) {
	    case 'e':
		cmd = 'E';
		break;
	    case 'i':
		cmd = 'I';
                break;
	    case 'w':			
		cmd = 'W';
		break;
	    case '&':			/* HCF... */
		cmd = '&';
		break;
	    default:
		goto usage;
	}
	s = socket(AF_UNIX, SOCK_STREAM, 0);
        if (s < 0) {
                fprintf(stderr,"couldn't get socket??!!\n");
                exit(1);
        }
	earwhere.sun_family = AF_UNIX; 
        strcpy(earwhere.sun_path, SOCKETNAME);
        if (connect(s, &earwhere, strlen(earwhere.sun_path) + 2) < 0) {
                fprintf(stderr,"couldn't connect to socket??!!\n");
                (void) close(s);
                exit(1);
        }
			/* who knows? might want to spew diatribe someday?...*/
	(void) sprintf(buf, "%c", cmd);
	n = strlen(buf);
	if (write(s,buf,n) != n) {
		fprintf(stderr,"couldn't write to socket??!!\n");
		(void) close(s);
		exit(1);
	}
	close(s);
}
